﻿#include "info-reader/feature-info-tokens-table.h"

/*!
 * @brief 地形属性トークンの定義 / Feature info flags
 */
const std::unordered_map<std::string_view, FloorFeatureType> f_info_flags = {
    { "LOS", FloorFeatureType::LOS },
    { "PROJECT", FloorFeatureType::PROJECT },
    { "MOVE", FloorFeatureType::MOVE },
    { "PLACE", FloorFeatureType::PLACE },
    { "DROP", FloorFeatureType::DROP },
    { "SECRET", FloorFeatureType::SECRET },
    { "NOTICE", FloorFeatureType::NOTICE },
    { "REMEMBER", FloorFeatureType::REMEMBER },
    { "OPEN", FloorFeatureType::OPEN },
    { "CLOSE", FloorFeatureType::CLOSE },
    { "BASH", FloorFeatureType::BASH },
    { "SPIKE", FloorFeatureType::SPIKE },
    { "DISARM", FloorFeatureType::DISARM },
    { "STORE", FloorFeatureType::STORE },
    { "TUNNEL", FloorFeatureType::TUNNEL },
    { "MAY_HAVE_GOLD", FloorFeatureType::MAY_HAVE_GOLD },
    { "HAS_GOLD", FloorFeatureType::HAS_GOLD },
    { "HAS_ITEM", FloorFeatureType::HAS_ITEM },
    { "DOOR", FloorFeatureType::DOOR },
    { "TRAP", FloorFeatureType::TRAP },
    { "STAIRS", FloorFeatureType::STAIRS },
    { "RUNE_PROTECTION", FloorFeatureType::RUNE_PROTECTION },
    { "LESS", FloorFeatureType::LESS },
    { "MORE", FloorFeatureType::MORE },
    { "AVOID_RUN", FloorFeatureType::AVOID_RUN },
    { "FLOOR", FloorFeatureType::FLOOR },
    { "WALL", FloorFeatureType::WALL },
    { "PERMANENT", FloorFeatureType::PERMANENT },
    // { "XXX00", FF::XXX00 },
    // { "XXX01", FF::XXX01 },
    // { "XXX02", FF::XXX02 },
    { "HIT_TRAP", FloorFeatureType::HIT_TRAP },

    // { "BRIDGE", FF::BRIDGE },
    // { "RIVER", FF::RIVER },
    // { "LAKE", FF::LAKE },
    // { "BRIDGED", FF::BRIDGED },
    // { "COVERED", FF::COVERED },
    { "GLOW", FloorFeatureType::GLOW },
    { "ENSECRET", FloorFeatureType::ENSECRET },
    { "WATER", FloorFeatureType::WATER },
    { "LAVA", FloorFeatureType::LAVA },
    { "SHALLOW", FloorFeatureType::SHALLOW },
    { "DEEP", FloorFeatureType::DEEP },
    { "POISON_PUDDLE", FloorFeatureType::POISON_PUDDLE },
    { "HURT_ROCK", FloorFeatureType::HURT_ROCK },
    // { "HURT_FIRE", FF::HURT_FIRE },
    // { "HURT_COLD", FF::HURT_COLD },
    // { "HURT_ACID", FF::HURT_ACID },
    { "COLD_PUDDLE", FloorFeatureType::COLD_PUDDLE },
    { "ACID_PUDDLE", FloorFeatureType::ACID_PUDDLE },
    // { "OIL", FF::OIL },
    { "ELEC_PUDDLE", FloorFeatureType::ELEC_PUDDLE },
    // { "CAN_CLIMB", FF::CAN_CLIMB },
    { "CAN_FLY", FloorFeatureType::CAN_FLY },
    { "CAN_SWIM", FloorFeatureType::CAN_SWIM },
    { "CAN_PASS", FloorFeatureType::CAN_PASS },
    // { "CAN_OOZE", FF::CAN_OOZE },
    { "CAN_DIG", FloorFeatureType::CAN_DIG },
    // { "HIDE_ITEM", FF::HIDE_ITEM },
    // { "HIDE_SNEAK", FF::HIDE_SNEAK },
    // { "HIDE_SWIM", FF::HIDE_SWIM },
    // { "HIDE_DIG", FF::HIDE_DIG },
    // { "KILL_HUGE", FF::KILL_HUGE },
    // { "KILL_MOVE", FF::KILL_MOVE },

    // { "PICK_TRAP", FF::PICK_TRAP },
    // { "PICK_DOOR", FF::PICK_DOOR },
    // { "ALLOC", FF::ALLOC },
    // { "CHEST", FF::CHEST },
    // { "DROP_1D2", FF::DROP_1D2 },
    // { "DROP_2D2", FF::DROP_2D2 },
    // { "DROP_GOOD", FF::DROP_GOOD },
    // { "DROP_GREAT", FF::DROP_GREAT },
    // { "HURT_POIS", FF::HURT_POIS },
    // { "HURT_ELEC", FF::HURT_ELEC },
    // { "HURT_WATER", FF::HURT_WATER },
    // { "HURT_BWATER", FF::HURT_BWATER },
    // { "USE_FEAT", FF::USE_FEAT },
    // { "GET_FEAT", FF::GET_FEAT },
    // { "GROUND", FF::GROUND },
    // { "OUTSIDE", FF::OUTSIDE },
    // { "EASY_HIDE", FF::EASY_HIDE },
    // { "EASY_CLIMB", FF::EASY_CLIMB },
    // { "MUST_CLIMB", FF::MUST_CLIMB },
    { "TREE", FloorFeatureType::TREE },
    // { "NEED_TREE", FF::NEED_TREE },
    // { "BLOOD", FF::BLOOD },
    // { "DUST", FF::DUST },
    // { "SLIME", FF::SLIME },
    { "PLANT", FloorFeatureType::PLANT },
    // { "XXX2", FF::XXX2 },
    // { "INSTANT", FF::INSTANT },
    // { "EXPLODE", FF::EXPLODE },
    // { "TIMED", FF::TIMED },
    // { "ERUPT", FF::ERUPT },
    // { "STRIKE", FF::STRIKE },
    // { "SPREAD", FF::SPREAD },

    { "SPECIAL", FloorFeatureType::SPECIAL },
    { "HURT_DISI", FloorFeatureType::HURT_DISI },
    { "QUEST_ENTER", FloorFeatureType::QUEST_ENTER },
    { "QUEST_EXIT", FloorFeatureType::QUEST_EXIT },
    { "QUEST", FloorFeatureType::QUEST },
    { "SHAFT", FloorFeatureType::SHAFT },
    { "MOUNTAIN", FloorFeatureType::MOUNTAIN },
    { "BLDG", FloorFeatureType::BLDG },
    { "RUNE_EXPLOSION", FloorFeatureType::RUNE_EXPLOSION },
    { "PATTERN", FloorFeatureType::PATTERN },
    { "TOWN", FloorFeatureType::TOWN },
    { "ENTRANCE", FloorFeatureType::ENTRANCE },
    { "MIRROR", FloorFeatureType::MIRROR },
    { "UNPERM", FloorFeatureType::UNPERM },
    { "TELEPORTABLE", FloorFeatureType::TELEPORTABLE },
    { "CONVERT", FloorFeatureType::CONVERT },
    { "GLASS", FloorFeatureType::GLASS },
};
